;Script files for QIP  Infium Instant Messenger 
; Require: InfiumHelper.jss
; Distributed by www.tiflocomp.ru


Include "HjGlobal.jsh" ; default HJ global variables
Include "hjconst.jsh" ; default HJ constants
Include "HjHelp.jsh" ; Help Topic Constants
Include "common.jsm" ; message file
Include "infium.jsm"
const
qiVirtualTreeClass1 = "TVirtualDrawTree",
qiVirtualTreeClass2 ="TVirtualStringTree",
qiRichViewClass = "TRichView",
qiRichEditClass = "TInfuRichViewEdit", 
qiInfoPanelClass = "TInfuPanel.UnicodeClass",
qiMsgFormClass = "TMsgForm.UnicodeClass",
qiTreeHintClass = "TVirtualTreeHintWindow",
qiHintClass = "TQipHintWindow.UnicodeClass"

globals
; the list of messages
Object qip_oMsgCollection,

; limiting mumber of messages in the list
int qip_nMaxCount

void Function AutoStartEvent()
	if not qip_oMsgCollection  then
		let qip_oMsgCollection = CreateObject("Scripting.Dictionary")
		let qip_nMaxCount = 10
	Endif
	return AutoStartEvent()
EndFunction

Void Function SayNonHighlightedText (handle hwnd, string sBuffer)
if not StringCompare(GetWindowClass(hWnd), qiTreeHintClass) then
Say(sBuffer, OT_SCREEN_MESSAGE)
Endif
return SayNonHighlightedText (hwnd, sbuffer)
EndFunction

int Function HandleCustomWindows (handle hWnd)
if GetObjectSubtype ()  == 3 then
Say(GetWindowText(GetParent (hWnd),0),OT_CONTROL_NAME)
endif

return HandleCustomWindows (hWnd)

EndFunction

Script ScriptFileName ()
ScriptAndAppNames(msgInfiumApp)
EndScript

void function HomeEndMovement(int UnitMovement)
HomeEndMovement(UnitMovement)
var 
string sClass
let sClass = GetWindowClass(GetFocus())
if IsPCCursor () 
&& (sClass == qiVirtualTreeClass1 || sClass  == qiVirtualTreeClass2) then
Say(GetLine(), OT_MESSAGE);
endIf
EndFunction

void function SayCharacterUnit(int UnitMovement)
SayCharacterUnit(UnitMovement)
var
string sClass
let sClass = GetWindowClass(GetFocus())
if IsPCCursor () 
&& (sClass == qiVirtualTreeClass1 || sClass  == qiVirtualTreeClass2) then
; SayTreeViewLevel(FALSE)
SayTreeViewItem()
endIf
EndFunction

void function SayLineUnit(int unitMovement, int bMoved)
SayLineUnit(unitMovement, bMoved)
var
string sClass
let sClass = GetWindowClass(GetFocus())
if IsPCCursor ()
&& (sClass == qiVirtualTreeClass1 || sClass  == qiVirtualTreeClass2) then
; SayTreeViewLevel(FALSE)
SayTreeViewItem()
endIf
EndFunction

Script SayMsgByIndex (int nIndex)
var 
int nCount

let nCount = qip_oMsgCollection.Count 
if not nCount then
	SayMessage (ot_error, cmsgNoMessages_L, cmsgNoMessages_S)
return
endif

if  nCount>= nIndex then
Say(qip_oMsgCollection.Item(nIndex-1),OT_MESSAGE)
if IsSameScript () then
	If UserBufferIsActive () then
		UserBufferDeactivate ()
	EndIf
	SayMessage (OT_USER_BUFFER, qip_oMsgCollection.Item(nIndex-1))
endif
endif
EndScript


Script SayBottomLineOfWindow ()
var
handle hWnd,
handle hApp

let hWnd = GetFocus()
let hApp = GetAppMainWindow (hWnd)
if not StringCompare(GetWindowClass(hApp), qiMsgFormClass)
&& not StringCompare(GetWindowClass(hWnd),qiRichEditClass)  
then
	Say(GetWindowText (GetNextWindow (GetNextWindow (hWnd)),0),ot_user_requested_information)
return
endif

PerformScript SayBottomLineOfWindow ()
EndScript


Script RefreshMessageList ()
let qip_oMsgCollection = CreateObject("Scripting.Dictionary")
if qip_oMsgCollection  then
	SayMessage (ot_MESSAGE, cmsgRefreshMessages_L, cmsgRefreshMessages_S)
EndIf


EndScript
